﻿using UnityEngine;

namespace Test
{
    public class Booom : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("Fragments/3.png", 180f);
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(255f, 20f, 147f, 1f);
            handSprite.sortingLayerName = "Top";
            hand.AddComponent<ExplosiveBehaviour>();
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 2f)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 6;
                ModAPI.CreateParticleEffect("FuseBlown", new Vector2(hand.transform.position.x, hand.transform.position.y + 0.1f));
                hand.GetComponent<ExplosiveBehaviour>().Activate();
                hand.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 5f;
                hand.GetComponent<ExplosiveBehaviour>().FragmentForce = 4f;
                hand.GetComponent<ExplosiveBehaviour>().Delay = 3.5f;
                hand.GetComponent<ExplosiveBehaviour>().Range = 30f;
                hand.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
                hand.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 18;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= 5f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(255f, 20f, 147f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0f);
            }
        }
    }
}
