﻿using UnityEngine;

namespace Test
{
    public class Cyberfoot : MonoBehaviour
    {

        private GameObject Foot;

        private GameObject Footglow;

        public void Awake()
        {
            Foot = gameObject;

            Footglow = new GameObject();
            Footglow.transform.parent = Foot.transform;
            Footglow.transform.localPosition = new Vector3(-0.1282f, 1.0865f);
            Footglow.transform.localScale = gameObject.transform.parent.localScale;

            var FootSprite = Footglow.AddComponent<SpriteRenderer>();

            FootSprite.sprite = ModAPI.LoadSprite("Fragments/cyborgfoot.png");
            FootSprite.material = ModAPI.FindMaterial("VeryBright");
            FootSprite.color = new Color(0f, 255f, 255f, 1f);
            FootSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Foot.GetComponent<Rigidbody2D>();
            if (rb.velocity.magnitude >= 5f)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 3;
                ModAPI.CreateParticleEffect("Disintegration", new Vector2(Foot.transform.position.x, Foot.transform.position.y + 0.1f));
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 3;
                other.gameObject.GetComponent<LimbBehaviour>().BreakBone();
                other.gameObject.GetComponent<LimbBehaviour>().Wince(30f);
                other.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
            }
        }

        public void FixedUpdate()
        {
            if (Foot.GetComponent<Rigidbody2D>().velocity.magnitude >= 5f)
            {
                Footglow.GetComponent<SpriteRenderer>().color = new Color(0f, 255f, 255f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                Footglow.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, 1f);
            }
        }
    }
}
