﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Test
{
    public class Doctor : MonoBehaviour
    {

        private GameObject Ruka;

        private GameObject RukaGlow;

        public Boolean Nullified = false;

        public void Awake()
        {
            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;

            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = ModAPI.LoadSprite("Fragments/Voron.png", 150f);
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(255f, 127f, 80f, 0f);
            RukaSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            var dr = other.gameObject.GetComponent<LimbBehaviour>();
            if (Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
                {
                    dr.Health = 0f;
                    ModAPI.CreateParticleEffect("BloodExplosion", new Vector2(Ruka.transform.position.x, Ruka.transform.position.y + 0.1f));
                }

            }

        }

        public void FixedUpdate()
        {
            if(Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(255f, 127f, 80f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
                }
                else
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.255f, 0.127f, 0.80f, 0f);
                }
            }

        }
    }
}
