﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Test
{
    public class GunBehBolt4 : MonoBehaviour
    {
        GameObject spr;
        public float Speed = 30f;
        public float ImpactStrength = 40f;
        public float Damage = 50000f;
        public float Range = 5000f;

        private RaycastHit2D hit;
        private PhysicalBehaviour hitPhys;

        private RaycastHit2D[] buffer = new RaycastHit2D[16];
        private LayerMask layerMask;

        private void Start()
        {
            spr = gameObject;
            spr.AddComponent<SpriteRenderer>();
            spr.GetComponent<SpriteRenderer>().sprite = powersprites.sword;
            spr.GetComponent<SpriteRenderer>().color = new Color(255f, 0f, 0.1f, 0.09f);
            spr.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            layerMask = LayerMask.GetMask("Bounds", "Objects", "CollidingDebris");
        }

        private void Update()
        {
            var translation = Speed * Time.deltaTime;
            Vector2 up = default(Vector2);
            if (CastRay(translation, out up))
            {
            }
            else
            {
                MonoBehaviour.Destroy(gameObject);
                ModAPI.CreateParticleEffect("BlasterImpact", transform.position).transform.up = up;
            }
        }




        private bool CastRay(float distance, out Vector2 normal)
        {
            normal = Vector2.up;
            var pos = transform.position;
            var end = pos + transform.right * distance;
            var hitCount = Physics2D.LinecastNonAlloc(pos, end, buffer);

            for (int i = 0; i < hitCount; i++)
            {
                var hit = buffer[i];

                normal = hit.normal;
                hit.transform.SendMessage("BreakBoneInternal");
                var hitEffect = ModAPI.CreateParticleEffect("BlasterImpact", transform.position);
                hitEffect.transform.SetParent(hit.transform);
                hitEffect.transform.position = hit.point;

                if (hit.collider.attachedRigidbody)
                    hit.collider.attachedRigidbody.AddForceAtPosition(hit.normal * -ImpactStrength, hit.point);
            }

            transform.position = end;
            return hitCount == 0;
        }
    }
}
