﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Test
{
    public class Heal : MonoBehaviour
    {

        private GameObject Ruka;

        private GameObject RukaGlow;

        public Boolean Nullified = false;

        public void Awake()
        {
            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;

            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = ModAPI.LoadSprite("Fragments/Krest.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 0f, 1f, 0.25f);
            RukaSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            var dr = other.gameObject.GetComponent<LimbBehaviour>();
            if (Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
                {
                    dr.HealBone();
                    dr.Health = dr.InitialHealth;
                    dr.Numbness = 0f;
                    dr.CirculationBehaviour.HealBleeding();
                    dr.CirculationBehaviour.IsPump = dr.CirculationBehaviour.WasInitiallyPumping;
                    dr.CirculationBehaviour.BloodFlow = 5f;
                    dr.CirculationBehaviour.AddLiquid(dr.GetOriginalBloodType(), 5f);
                    dr.BruiseCount = 0;
                    dr.CirculationBehaviour.GunshotWoundCount = 0;
                    dr.CirculationBehaviour.StabWoundCount = 0;

                    dr.Person.Consciousness = 1f;
                    dr.Person.ShockLevel = 0f;
                    dr.Person.PainLevel = 0f;
                    dr.Person.OxygenLevel = 1f;
                    dr.Person.AdrenalineLevel = 1f;
                    dr.SkinMaterialHandler.RottenProgress = 0f;
                    dr.SkinMaterialHandler.AcidProgress = 0f;
                    dr.PhysicalBehaviour.BurnProgress = 0f;
                }

            }

        }

        public void FixedUpdate()
        {
            if(Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
                }
                else
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
                }
            }

        }
    }
}
