 using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Test
{
    public class Test
    {
        public static void Main()
        {

          CategoryBuilder.Create("MHW", "", ModAPI.LoadSprite("InGameIcon.png"));

          //DPistol
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Revolver"),
                  NameOverride = "Demonic Pistol",
                  NameToOrderByOverride = "R1",
                  DescriptionOverride = "A magical gun used by demons. On hit, the target ignites."+"\n <color=orange>WARNING: do not shoot at the floor please!. ",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("Dviwe.png", 5f),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Demon pistol.png", 13.5f);
                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                      customCartridge.name = "5.45x39mm DPistol";
                      customCartridge.Damage *= 15;
                      customCartridge.StartSpeed *= 15f;
                      customCartridge.Recoil *= 3f;
                      firearm.Cartridge = customCartridge;
                      Instance.FixColliders();
                      firearm.ShotSounds = new AudioClip[]
                      {
                          ModAPI.LoadSound("Zvukk2.mp3")
                      };
                          Instance.FixColliders();
                          Instance.AddComponent<DPistol>();
                  }
              }
          );
              //arrow
              ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
                  NameOverride = "Arrow",
                  NameToOrderByOverride = "Arrow",
                  DescriptionOverride = "An ordinary arrow made by goblins from pieces of iron and bird feathers.",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("Arrow_Icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.AddComponent<BoxCollider2D>();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("arrow.png", 10.5f);
                  }
              }
          );
             //WoodenBow
             ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                  NameOverride = "Goblin Wooden Bow",
                  DescriptionOverride = "A regular wooden bow that goblins made to fight.",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("Bow_Icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      var PipeWallOne = Instance.AddComponent<BoxCollider2D>();
                      PipeWallOne.size = new Vector2(0.3f, 1f);
                      PipeWallOne.offset = new Vector2(0f, 0f);
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("WoodenBow.png", 12f);
                      Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Arrow");
                      Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      phys.Properties = ModAPI.FindPhysicalProperties("Wood");
                      Instance.FixColliders();
                  }
              }
          );

          //arrow(Fire FireAbillity)
          ModAPI.Register(
          new Modification()
          {
              OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
              NameOverride = "Fire Arrow",
              NameToOrderByOverride = "Fire Arrow",
              DescriptionOverride = "The magic arrow, which was made by the goblins sorcerers, was created from enchanted metal and from the feathers of a fiery bird.",
              CategoryOverride = ModAPI.FindCategory("MHW"),
              ThumbnailOverride = ModAPI.LoadSprite("FireArrow_Icon.png"),
              AfterSpawn = (Instance) =>
              {
                  Instance.AddComponent<BoxCollider2D>();
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("arrow(FireAbillity).png", 10.5f);
                  Instance.AddComponent<GreenBrickSword>();
              }
          }
      );

      //arrow(ZupAbillity)
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
          NameOverride = "Electric Arrow",
          NameToOrderByOverride = "Electric Arrow",
          DescriptionOverride = "The magic arrow, which was made by the goblin sorcerers, was created from magic thunderstone and durable metal.",
          CategoryOverride = ModAPI.FindCategory("MHW"),
          ThumbnailOverride = ModAPI.LoadSprite("ElectricArrow_Icon.png"),
          AfterSpawn = (Instance) =>
          {
              Instance.AddComponent<BoxCollider2D>();
              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("arrow(Energy2).png", 10.5f);
              Instance.AddComponent<BoltArrow>();
          }
      }
  );
         //WoodenBow(FireAbillity)
         ModAPI.Register(
          new Modification()
          {
              OriginalItem = ModAPI.FindSpawnable("Crossbow"),
              NameOverride = "Goblin Magic Wooden Bow",
              DescriptionOverride = "A magic bow that shoots enchanted arrows, mostly owned by elite goblins.",
              CategoryOverride = ModAPI.FindCategory("MHW"),
              ThumbnailOverride = ModAPI.LoadSprite("Magic Wooden Bow_Icon.png"),
              AfterSpawn = (Instance) =>
              {
                  foreach (var c in Instance.GetComponents<Collider2D>())
                  {
                      GameObject.Destroy(c);
                  }
                  var PipeWallOne = Instance.AddComponent<BoxCollider2D>();
                  PipeWallOne.size = new Vector2(0.3f, 1f);
                  PipeWallOne.offset = new Vector2(0f, 0f);
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("WoodenBow(FireAbility).png", 12f);
                  Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Fire Arrow");
                  Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                  Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                  var phys = Instance.GetComponent<PhysicalBehaviour>();
                  phys.Properties = ModAPI.FindPhysicalProperties("Wood");
                  var childObject = new GameObject();
                  childObject.transform.SetParent(Instance.transform);
                  childObject.transform.localPosition = new Vector3(0.087f, -0.005f);
                  childObject.transform.localScale = new Vector3(1f, 1f);
                  var childSprite = childObject.AddComponent<SpriteRenderer>();
                  childSprite.sprite = ModAPI.LoadSprite("Fragments/BowFireSprite.png", 12f);
                  childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                  childSprite.color = new Color(255f, 69f, 0f, 0.045f);
                  Instance.AddComponent<BoxCollider2D>();
                  childSprite.sortingLayerName = "Top";
                  Instance.FixColliders();
              }
          }
      );

      //WoodenBow(Zup)
      ModAPI.Register(
       new Modification()
       {
           OriginalItem = ModAPI.FindSpawnable("Crossbow"),
           NameOverride = "Goblin Electric Magic Wooden Bow",
           DescriptionOverride = "A magic bow that shoots enchanted arrows, mostly owned by elite goblins.",
           CategoryOverride = ModAPI.FindCategory("MHW"),
           ThumbnailOverride = ModAPI.LoadSprite("Electric Wooden Bow_Icon.png"),
           AfterSpawn = (Instance) =>
           {
               foreach (var c in Instance.GetComponents<Collider2D>())
               {
                   GameObject.Destroy(c);
               }
               var PipeWallOne = Instance.AddComponent<BoxCollider2D>();
               PipeWallOne.size = new Vector2(0.3f, 1f);
               PipeWallOne.offset = new Vector2(0f, 0f);
               Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("WoodenBow(ZupAbility).png", 12f);
               Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Electric Arrow");
               Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
               Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
               var phys = Instance.GetComponent<PhysicalBehaviour>();
               phys.Properties = ModAPI.FindPhysicalProperties("Wood");
               var childObject = new GameObject();
               childObject.transform.SetParent(Instance.transform);
               childObject.transform.localPosition = new Vector3(0.087f, -0.005f);
               childObject.transform.localScale = new Vector3(1f, 1f);
               var childSprite = childObject.AddComponent<SpriteRenderer>();
               childSprite.sprite = ModAPI.LoadSprite("Fragments/WoodenBow(ZupAbility)Sprite.png", 12f);
               childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
               childSprite.color = new Color(147f, 112f, 219f, 0.045f);
               Instance.AddComponent<BoxCollider2D>();
               childSprite.sortingLayerName = "Top";
               Instance.FixColliders();
           }
       }
   );

            //Ice Hammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Hammer"),
                    NameOverride = "Ice Molot",
                    NameToOrderByOverride = "Molot",
                    DescriptionOverride = "Giant Ice Hammer made by the Ice Giant.",
                    CategoryOverride = ModAPI.FindCategory("MHW"),
                    ThumbnailOverride = ModAPI.LoadSprite("Ice_Molot_Icon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Ice_Molot.png", 1.8f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 25f;
                        Instance.FixColliders();
                    }
                }
            );


            //CLAHead
            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Rod"),
                 NameOverride = "Cursed Lord's Armor - Helmet",
                 NameToOrderByOverride = "Cursed Lord's Armor - Helmet",
                 DescriptionOverride = "Armor that was forged for the Cursed Lord to hide his gruesome appearance.",
                 CategoryOverride = ModAPI.FindCategory("MHW"),
                 ThumbnailOverride = ModAPI.LoadSprite("Shlem_view.png", 1f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CLAHead.png");
                     armorbehaviour armor = Instance.AddComponent<armorbehaviour>();

                     armor.stabResistance = 300f;
                     armor.armorPiece = "Head";
                     armor.armorTier = 3;

                     var childObject = new GameObject();
                     childObject.transform.SetParent(Instance.transform);
                     childObject.transform.localPosition = new Vector3(0, 0f);
                     childObject.transform.localScale = new Vector3(1f, 1f);
                     var childSprite = childObject.AddComponent<SpriteRenderer>();
                     childSprite.sprite = ModAPI.LoadSprite("Fragments/CLAHeadSprite.png");
                     childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                     childSprite.color = new Color(139f, 0f, 0f, 0.1f);
                     childSprite.sortingLayerName = "Top";

         Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
         Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                     Instance.FixColliders();
                 }
             }
         );
         //Shoulders
         ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Rod"),
                 NameOverride = "Cursed Lord's Armor - Shoulder",
                 NameToOrderByOverride = "A",
                 DescriptionOverride = "Armor that was forged for the Cursed Lord to hide his gruesome appearance.",
                 CategoryOverride = ModAPI.FindCategory("MHW"),
                 ThumbnailOverride = ModAPI.LoadSprite("UpperArm_View.png"),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CLAUpperArm.png");
                     armorbehaviour armor = Instance.AddComponent<armorbehaviour>();
                     armor.stabResistance = 1000f;
                     armor.armorPiece = "UpperArm";
                     armor.armorTier = 3;
                     armor.otherSprite = "CLAUpperArm.png";
                     armor.otherName = "Cursed Lord's Armor - Shoulder";
                     armor.otherPiece = "UpperArmFront";
                     armor.otherTier = 3;
                     armor.otherResist = 5f;
                     armor.SpawnOtherParts();
                     Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
         Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                     Instance.FixColliders();
                 }
             }
         );


         //legs
         ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Rod"),
                 NameOverride = "Cursed Lord's Armor - Legs",
                 NameToOrderByOverride = "A",
                 DescriptionOverride = "Armor that was forged for the Cursed Lord to hide his gruesome appearance.",
                 CategoryOverride = ModAPI.FindCategory("MHW"),
                 ThumbnailOverride = ModAPI.LoadSprite("Legs_view.png"),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CLALeg.png");
                     armorbehaviour armor = Instance.AddComponent<armorbehaviour>();
                     armor.stabResistance = 1000f;
                     armor.armorPiece = "LowerLeg";
                     armor.armorTier = 3;
                     armor.otherSprite = "CLALeg.png";
                     armor.otherName = "Cursed Lord's Armor - Legs";
                     armor.otherPiece = "LowerLegFront";
                     armor.otherTier = 3;
                     armor.otherResist = 1000f;
                     armor.SpawnOtherParts();
                     Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
         Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                     Instance.FixColliders();
                 }
             }
         );

         //Thigh-pads
         ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Rod"),
                 NameOverride = "Cursed Lord's Armor - Thigh-pads",
                 NameToOrderByOverride = "A",
                 DescriptionOverride = "Armor that was forged for the Cursed Lord to hide his gruesome appearance.",
                 CategoryOverride = ModAPI.FindCategory("MHW"),
                 ThumbnailOverride = ModAPI.LoadSprite("Thig-Pads_View.png"),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CLAUpperLeg.png");
                     armorbehaviour armor = Instance.AddComponent<armorbehaviour>();
                     armor.stabResistance = 1000f;
                     armor.armorPiece = "UpperLeg";
                     armor.armorTier = 3;
                     armor.otherSprite = "CLAUpperLeg.png";
                     armor.otherName = "Cursed Lord's Armor - Thigh-pads";
                     armor.otherPiece = "UpperLegFront";
                     armor.otherTier = 3;
                     armor.otherResist = 1000f;
                     armor.SpawnOtherParts();
                     Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
         Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                     Instance.FixColliders();
                 }
             }
         );

         //Chest
         ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Rod"),
                 NameOverride = "Cursed Lord's Armor - Top",
                 NameToOrderByOverride = "Cursed Lord's Armor - Top",
                 DescriptionOverride = "Armor that was forged for the Cursed Lord to hide his gruesome appearance.",
                 CategoryOverride = ModAPI.FindCategory("MHW"),
                 ThumbnailOverride = ModAPI.LoadSprite("Top_View.png"),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CLATop.png");
                     armorbehaviour armor = Instance.AddComponent<armorbehaviour>();

                     armor.stabResistance = 1000f;
                     armor.armorPiece = "UpperBody";
                     armor.armorTier = 3;
                     Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                     Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                     Instance.FixColliders();
                 }
             }
         );
         //Chestplates
         ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Rod"),
                 NameOverride = "Cursed Lord's Armor - Middle and Bottom",
                 NameToOrderByOverride = "A",
                 DescriptionOverride = "Armor that was forged for the Cursed Lord to hide his gruesome appearance.",
                 CategoryOverride = ModAPI.FindCategory("MHW"),
                 ThumbnailOverride = ModAPI.LoadSprite("M and L_view.png"),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CLAMiddle.png");
                     armorbehaviour armor = Instance.AddComponent<armorbehaviour>();

                     armor.stabResistance = 1000f;
                     armor.armorPiece = "MiddleBody";
                     armor.armorTier = 3;
                     armor.otherSprite = "CLALower.png";
                     armor.otherName = "Cursed Lord's Armor - Middle and Bottom";
                     armor.otherPiece = "LowerBody";
                     armor.otherTier = 3;
                     armor.otherResist = 1000f;
                     armor.SpawnOtherParts();

                     Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
         Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                     Instance.FixColliders();
                 }
             }
         );
         //Shoes
         ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Rod"),
                 NameOverride = "Cursed Lord's Armor - Shoes",
                 NameToOrderByOverride = "Cursed Lord's Armor - Shoes",
                 DescriptionOverride = "Armor that was forged for the Cursed Lord to hide his gruesome appearance.",
                 CategoryOverride = ModAPI.FindCategory("MHW"),
                 ThumbnailOverride = ModAPI.LoadSprite("Shoes_View.png"),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CLAFoot.png");
                     armorbehaviour armor = Instance.AddComponent<armorbehaviour>();
                     armor.stabResistance = 1000f;
                     armor.armorPiece = "Foot";
                     armor.armorTier = 3;
                     armor.otherSprite = "CLAFoot.png";
                     armor.otherName = "Cursed Lord's Armor - Shoes";
                     armor.otherPiece = "FootFront";
                     armor.otherTier = 3;
                     armor.otherResist = 1000f;
                     armor.SpawnOtherParts();
                     Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
         Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                     Instance.FixColliders();
                 }
             }
         );


          //Virus Dagger
            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Unknown Dagger",
                  NameToOrderByOverride = "DD",
                  DescriptionOverride = "An unknown dagger that has a lethal effect. The employees of the mysterious research center called this dagger a relic. However, when an employee wanted to frame this object, he touched the blade and died instantly, and his body became rotten.",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("Virus Knife_viwe.png", 5f),
                  AfterSpawn = (generatorInstance) =>
                  {
                    generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("virus knife.png", 26f);
                    generatorInstance.AddComponent<GreenBrickSword4>();

                  }
              }
          );
          //Sword of the damned lord
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Sword"),
                  NameOverride = "Sword of the damned lord",
                  DescriptionOverride = ""+"\n <color=red>The sword of the damned, bloodthirsty and hated lord. As damned as its owner. It sucks the soul and all the life force of the enemy, turning the body of the enemy into a lifeless and rotten statue.",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("CLSword_view.png", 5f),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sword of the damned lord3.png", 1.75f);
                      Instance.AddComponent<Swordofthedamnedlord>();
                  }
              }
          );




          //APistol
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Revolver"),
                  NameOverride = "Anti Demonic Pistol",
                  NameToOrderByOverride = "R1",
                  DescriptionOverride = "A very powerful revolver designed against demons. When hit, the victim is charred.",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("APviwe.png", 5f),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AntiDemonicPistol.png", 18.5f);
                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                      customCartridge.name = "5.45x39mm ARevolver";
                      customCartridge.Damage *= 15;
                      customCartridge.StartSpeed *= 15f;
                      customCartridge.Recoil *= 3f;
                      firearm.Cartridge = customCartridge;
                      Instance.FixColliders();
                      firearm.ShotSounds = new AudioClip[]
                      {
                          ModAPI.LoadSound("Zvukk.mp3")
                      };
                      Instance.FixColliders();
                      Instance.AddComponent<Test2>();
                  }
              }
          );

           //Ice Giant
          ModAPI.Register(
          new Modification()
          {
              OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
              NameOverride = ""+"\n <color=red>Ice Giant", //new item name with a suffix to assure it is globally unique
              DescriptionOverride = ""+"\n <color=red>A mighty giant of the jotun race. He walks with a huge hammer that he made himself. There is also ice protection, touching the giant, the enemy will immediately freeze.", //new item description
              CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
              ThumbnailOverride = ModAPI.LoadSprite("Ice_Giant_Icon.png"), //new item thumbnail (relative path)
              AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
              {
                  //load textures for each layer (see Human textures folder in this repository)
                  var skin = ModAPI.LoadTexture("Velikan_end.png");
                  var flesh = ModAPI.LoadTexture("ice_flesh.png");
                  var bone = ModAPI.LoadTexture("Ice_Skelet.png");

                  var person = Instance.GetComponent<PersonBehaviour>();

                  var head = Instance.transform.Find("Head");
                  var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                  var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                  var upper = Instance.transform.Find("Body").Find("UpperBody");

                  GameObject eye = new GameObject();
                  eye.transform.parent = head;
                  eye.transform.localPosition = new Vector3(-0.071f, -0.971f);
                  eye.transform.localScale = new Vector3(1f, 1f);

                  var eyeSprite = eye.AddComponent<SpriteRenderer>();

                  eyeSprite.sprite = ModAPI.LoadSprite("Fragments/Velikan_eye.png");
                  eyeSprite.sortingLayerName = "Top";
                  eyeSprite.material = ModAPI.FindMaterial("VeryBright");
                  eyeSprite.color = new Color(205f, 92f, 92f, 0.05f);


                  foreach (var body in person.Limbs)
                  {
                      body.BaseStrength += 200f;
                      body.Health *= 400000f;
                      body.InitialHealth *= 400000f;
                      body.ShotDamageMultiplier *= -2f;
                      body.BreakingThreshold += 400000f;
                      body.RegenerationSpeed += 400000f;
                      body.Vitality *= 40000f;
                      body.ImpactPainMultiplier *= 0f;
                      body.Numbness *= 3f;
                      body.CirculationBehaviour.BloodFlow *= 4000f;
                      body.IsLethalToBreak = false;
                      body.gameObject.AddComponent<DG>();
                      body.transform.root.localScale *= 1.138f;
                      body.IsAndroid = true;
                      body.PhysicalBehaviour.ReflectsLasers = true;
                      body.gameObject.AddComponent<Ice_Giant>();

                  }



                  //use the helper function to set each texture
                  //parameters are as follows:
                  //  skin texture, flesh texture, bone texture, sprite scale
                  //you can pass "null" to fall back to the original texture
                  person.SetBodyTextures(skin, flesh, bone, 1);
                  person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                  person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                  person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                  person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                  person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
              }
          }
      );

      //Troll
     ModAPI.Register(
     new Modification()
     {
         OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
         NameOverride = ""+"\n <color=yellow>Troll", //new item name with a suffix to assure it is globally unique
         DescriptionOverride = ""+"\n <color=yellow>a supernatural creature that protects its territory from outsiders, although trolls are usually hostile to humans, but this species is neutral to humans. But it's better not to make him angry...", //new item description
         CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
         ThumbnailOverride = ModAPI.LoadSprite("Troll_viwe.png"), //new item thumbnail (relative path)
         AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
         {
             //load textures for each layer (see Human textures folder in this repository)
             var skin = ModAPI.LoadTexture("Troll.png");
             var flesh = ModAPI.LoadTexture("cflesh.png");
             var bone = ModAPI.LoadTexture("bone layer.png");

             var person = Instance.GetComponent<PersonBehaviour>();

             var head = Instance.transform.Find("Head");
             var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
             var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
             var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
             var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
             var upper = Instance.transform.Find("Body").Find("UpperBody");

             arm1.gameObject.AddComponent<Troll>();
             arm2.gameObject.AddComponent<Troll>();
             leg1.gameObject.AddComponent<Troll>();
             leg2.gameObject.AddComponent<Troll>();

             foreach (var body in person.Limbs)
             {
                 body.BaseStrength += 10f;
                 body.Health *= 50000f;
                 body.InitialHealth *= 50000f;
                 body.ShotDamageMultiplier *= -2f;
                 body.BreakingThreshold += 50000f;
                 body.RegenerationSpeed += 50000f;
                 body.Vitality *= 50000f;
                 body.ImpactPainMultiplier *= 0f;
                 body.Numbness *= 3f;
                 body.CirculationBehaviour.BloodFlow *= 50000f;
                 body.IsLethalToBreak = false;
                 body.gameObject.AddComponent<DG>();
                 body.transform.root.localScale *= 1.023f;

             }



             //use the helper function to set each texture
             //parameters are as follows:
             //  skin texture, flesh texture, bone texture, sprite scale
             //you can pass "null" to fall back to the original texture
             person.SetBodyTextures(skin, flesh, bone, 1);
             person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
             person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
             person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
             person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
             person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
         }
     }
 );

          // Ctl
          ModAPI.Register(
          new Modification()
          {
              OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
              NameOverride = ""+"\n <color=red>????", //new item name with a suffix to assure it is globally unique
              DescriptionOverride = ""+"\n <color=red>????", //new item description
              CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
              ThumbnailOverride = ModAPI.LoadSprite("Ctl_view.png"), //new item thumbnail (relative path)
              AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
              {
                  //load textures for each layer (see Human textures folder in this repository)
                  var skin = ModAPI.LoadTexture("ctl.png");
                  var flesh = ModAPI.LoadTexture("ctl.png");
                  var bone = ModAPI.LoadTexture("Ctlbone.png");

                  var person = Instance.GetComponent<PersonBehaviour>();

                  var head = Instance.transform.Find("Head");
                  var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                  var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                  var upper = Instance.transform.Find("Body").Find("UpperBody");

                  GameObject eye = new GameObject();
                  eye.transform.parent = head;
                  eye.transform.localPosition = new Vector3(-0.071f, -0.971f);
                  eye.transform.localScale = new Vector3(1f, 1f);

                  var eyeSprite = eye.AddComponent<SpriteRenderer>();

                  eyeSprite.sprite = ModAPI.LoadSprite("Fragments/ctleye.png");
                  eyeSprite.sortingLayerName = "Top";
                  eyeSprite.material = ModAPI.FindMaterial("VeryBright");
                  eyeSprite.color = new Color(0f, 128f, 0f, 0.40f);


                  GameObject wings = new GameObject();
                  wings.transform.parent = upper;
                  wings.transform.localPosition = new Vector3(-0.50f, 0.15f);
                  wings.transform.localScale = new Vector3(1f, 1f);

                  var wingsSprite = wings.AddComponent<SpriteRenderer>();

                  wingsSprite.sprite = ModAPI.LoadSprite("Fragments/Ctl wings.png", 15f);
                  wingsSprite.sortingLayerName = "Top";

                  foreach (var body in person.Limbs)
                  {
                      body.BaseStrength += 200f;
                      body.Health *= 20000f;
                      body.InitialHealth *= 20000f;
                      body.ShotDamageMultiplier *= -2f;
                      body.BreakingThreshold += 20000f;
                      body.RegenerationSpeed += 20000f;
                      body.Vitality *= 2000f;
                      body.ImpactPainMultiplier *= 0f;
                      body.Numbness *= 3f;
                      body.CirculationBehaviour.BloodFlow *= 40f;
                      body.IsLethalToBreak = false;
                      body.gameObject.AddComponent<DG>();
                      body.transform.root.localScale *= 1.135f;
                      body.transform.localScale = new Vector3(1.25f, 1.1f);
                      body.IsAndroid = true;
                      body.PhysicalBehaviour.ReflectsLasers = true;

                  }



                  //use the helper function to set each texture
                  //parameters are as follows:
                  //  skin texture, flesh texture, bone texture, sprite scale
                  //you can pass "null" to fall back to the original texture
                  person.SetBodyTextures(skin, flesh, bone, 1);
                  person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                  person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                  person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                  person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                  person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
              }
          }
      );



      //alien
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "???", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=red>This creature can shoot an acid ball from its mouth, and its sharp claws tear the enemy apart.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Ctl_view.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("Allien.png");
              var flesh = ModAPI.LoadTexture("Alien_Flash.png");
              var bone = ModAPI.LoadTexture("Alien_Bone.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("LowerBody");
              GameObject chast1 = new GameObject();
              chast1.transform.parent = head;
              chast1.transform.localPosition = new Vector3(-0.38f, -0.973f);
              chast1.transform.localScale = new Vector3(1f, 1f);

              var chast1Sprite = chast1.AddComponent<SpriteRenderer>();
              head.gameObject.AddComponent<GunBeh3>();
              arm1.gameObject.AddComponent<Alien>();
              arm2.gameObject.AddComponent<Alien>();

              chast1Sprite.sprite = ModAPI.LoadSprite("Fragments/AllienFragment1.png");
              chast1Sprite.sortingLayerName = "Top";

              GameObject halo = new GameObject();
              halo.transform.parent = upper;
              halo.transform.localPosition = new Vector3(-0.75f, -0.2f);
              halo.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = halo.AddComponent<SpriteRenderer>();
              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/AllienFrament2.png", 3.5f);
              eyeSprite.sortingLayerName = "Top";

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }



              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );



      // Magic Ninja
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Magic Ninja", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=orange>A special warrior who was given secret missions. Has the ability (Explosive Shuriken). There were 5 such warriors, later they were called the Legion of the Far Side of the Moon.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Ninja_view.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("ninja.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("bone layer.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              GameObject eye = new GameObject();
              eye.transform.parent = head;
              eye.transform.localPosition = new Vector3(-0.1f, -0.97f);
              eye.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = eye.AddComponent<SpriteRenderer>();
              arm1.gameObject.AddComponent<GunBeh2>();
              arm2.gameObject.AddComponent<GunBeh2>();

              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/Ninjaeye.png");
              eyeSprite.material = ModAPI.FindMaterial("VeryBright");
              eyeSprite.color = new Color(220f, 20f, 60f, 0.30f);
              eyeSprite.sortingLayerName = "Top";

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 4.5f;
                  body.Health *= 10f;
                  body.InitialHealth *= 10f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 19f;
                  body.Vitality *= 19f;
                  body.ImpactPainMultiplier *= 0.2f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 19f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }



              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(158, 34, 34); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(140, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );

  //Goblun
  ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
      NameOverride = "Goblin", //new item name with a suffix to assure it is globally unique
      DescriptionOverride = ""+"\n <color=orange>Goblins are supernatural humanoid creatures that, according to Western European mythology, live in underground caves and cannot stand sunlight. Goblins are a type of fairies, or nature spirits such as pixies or gnomes.", //new item description
      CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
      ThumbnailOverride = ModAPI.LoadSprite("Goblin_Icon.png"), //new item thumbnail (relative path)
      AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
      {
          //load textures for each layer (see Human textures folder in this repository)
          var skin = ModAPI.LoadTexture("Goblin_concept.png");
          var flesh = ModAPI.LoadTexture("Cflesh.png");
          var bone = ModAPI.LoadTexture("GoblinBone.png");

          var person = Instance.GetComponent<PersonBehaviour>();

          var head = Instance.transform.Find("Head");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var upper = Instance.transform.Find("Body").Find("UpperBody");

          GameObject eye = new GameObject();
          eye.transform.parent = head;
          eye.transform.localPosition = new Vector3(-0.1f, -0.97f);
          eye.transform.localScale = new Vector3(1f, 1f);

          var eyeSprite = eye.AddComponent<SpriteRenderer>();

          eyeSprite.sprite = ModAPI.LoadSprite("Fragments/GoblinEye.png");
          eyeSprite.material = ModAPI.FindMaterial("VeryBright");
          eyeSprite.color = new Color(127f, 255f, 0f, 0.06f);
          eyeSprite.sortingLayerName = "Top";

          foreach (var body in person.Limbs)
          {
              body.BaseStrength += 1f;
              body.Health *= 20f;
              body.InitialHealth *= 20f;
              body.ShotDamageMultiplier *= 0.2f;
              body.BreakingThreshold += 11f;
              body.RegenerationSpeed += 10f;
              body.Vitality *= 30f;
              body.ImpactPainMultiplier *= 0.2f;
              body.Numbness *= 1f;
              body.CirculationBehaviour.BloodFlow *= 30f;
              body.IsLethalToBreak = false;
              body.gameObject.AddComponent<DG>();
              body.transform.root.localScale *= 0.988f;

          }



          //use the helper function to set each texture
          //parameters are as follows:
          //  skin texture, flesh texture, bone texture, sprite scale
          //you can pass "null" to fall back to the original texture
          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
          person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
          person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
          person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
          person.SetRottenColour(0, 0, 0);
      }
  }
);



          // DragonChel
          ModAPI.Register(
          new Modification()
          {
              OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
              NameOverride = "Dracolyte", //new item name with a suffix to assure it is globally unique
              DescriptionOverride = ""+"\n <color=orange>An A person who is afflicted with a rare disease that gradually turns a person into a dragon. Such people were considered monsters and outcasts Sets fire to touch.", //new item description
              CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
              ThumbnailOverride = ModAPI.LoadSprite("Dracolyteview.png"), //new item thumbnail (relative path)
              AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
              {
                  //load textures for each layer (see Human textures folder in this repository)
                  var skin = ModAPI.LoadTexture("Dragon_chel.png");
                  var flesh = ModAPI.LoadTexture("Cflesh.png");
                  var bone = ModAPI.LoadTexture("bone layer.png");

                  var person = Instance.GetComponent<PersonBehaviour>();

                  var head = Instance.transform.Find("Head");
                  var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                  var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                  var upper = Instance.transform.Find("Body").Find("UpperBody");
                  GameObject halo = new GameObject();
                  halo.transform.parent = upper;
                  halo.transform.localPosition = new Vector3(0.68f, -0.8f);
                  halo.transform.localScale = new Vector3(1f, 1f);

                  var eyeSprite = halo.AddComponent<SpriteRenderer>();
                  arm1.gameObject.AddComponent<Firebeh>();
                  arm2.gameObject.AddComponent<Firebeh>();

                  eyeSprite.sprite = ModAPI.LoadSprite("Fragments/Dwings.png");
                  eyeSprite.sortingLayerName = "Top";

                  foreach (var body in person.Limbs)
                  {
                      body.BaseStrength += 5.5f;
                      body.Health *= 3.3f;
                      body.InitialHealth *= 3.0f;
                      body.ShotDamageMultiplier *= 0.2f;
                      body.BreakingThreshold += 11f;
                      body.RegenerationSpeed += 14.5f;
                      body.Vitality *= 9f;
                      body.ImpactPainMultiplier *= 0.5f;
                      body.Numbness *= 1f;
                      body.CirculationBehaviour.BloodFlow *= 4f;
                      body.IsLethalToBreak = false;
                      body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                      body.gameObject.AddComponent<DG>();

                  }



                  //use the helper function to set each texture
                  //parameters are as follows:
                  //  skin texture, flesh texture, bone texture, sprite scale
                  //you can pass "null" to fall back to the original texture
                  person.SetBodyTextures(skin, flesh, bone, 1);
                  person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
                  person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
                  person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
                  person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
                  person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
              }
          }
      );


      //The Hermit
     ModAPI.Register(
     new Modification()
     {
         OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
         NameOverride = "The Hermit", //new item name with a suffix to assure it is globally unique
         DescriptionOverride = ""+"\n <color=green>A man in shabby clothes, who was called a hermit, because he wanders. But no one knows that he has magical powers(To activate the ability, press F on the hand).", //new item description
         CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
         ThumbnailOverride = ModAPI.LoadSprite("WView.png"), //new item thumbnail (relative path)
         AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
         {
             //load textures for each layer (see Human textures folder in this repository)
             var skin = ModAPI.LoadTexture("Wizzard.png");
             var flesh = ModAPI.LoadTexture("Cflesh.png");
             var bone = ModAPI.LoadTexture("bone layer.png");

             var person = Instance.GetComponent<PersonBehaviour>();

             var head = Instance.transform.Find("Head");
             var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
             var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
             var upper = Instance.transform.Find("Body").Find("UpperBody");
             var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
             var leg2 = Instance.transform.Find("BackLeg").Find("Foot");

             arm1.gameObject.AddComponent<GunBeh>();
             arm2.gameObject.AddComponent<GunBeh>();

             GameObject Hat = new GameObject();
             Hat.transform.parent = head;
             Hat.transform.localPosition = new Vector3(0f, 0.08f);
             Hat.transform.localScale = new Vector3(1f, 1f);

             var HatSprite = Hat.AddComponent<SpriteRenderer>();

             HatSprite.sprite = ModAPI.LoadSprite("Fragments/hat.png");
             HatSprite.sortingLayerName = "Top";

             foreach (var body in person.Limbs)
             {
                 body.BaseStrength += 4f;
                 body.Health *= 20f;
                 body.InitialHealth *= 20f;
                 body.ShotDamageMultiplier *= 0.2f;
                 body.BreakingThreshold += 10f;
                 body.RegenerationSpeed += 12f;
                 body.Vitality *= 20f;
                 body.ImpactPainMultiplier *= 0.2f;
                 body.Numbness *= 1f;
                 body.CirculationBehaviour.BloodFlow *= 150f;
                 body.IsLethalToBreak = false;
                 body.gameObject.AddComponent<DG>();


             }

             //use the helper function to set each texture
             //parameters are as follows:
             //  skin texture, flesh texture, bone texture, sprite scale
             //you can pass "null" to fall back to the original texture
           person.SetBodyTextures(skin, flesh, bone, 1);
           person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
           person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
           person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
           person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
           person.SetRottenColour(0, 0, 0);
         }
     }
 );



      //Plague Doctor
     ModAPI.Register(
     new Modification()
     {
         OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
         NameOverride = "Plague Doctor", //new item name with a suffix to assure it is globally unique
         DescriptionOverride = ""+"\n <color=red>Ring-a-ring o' roses. A pocket full of posies. A-tishoo. A-tishoo. We all fall down... (It infects people when it is near it, when it touches a person, it kills a part of the body. If a doctor touches a person's face with a plague, the same person will die immediately.)", //new item description
         CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
         ThumbnailOverride = ModAPI.LoadSprite("Doc_View.png"), //new item thumbnail (relative path)
         AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
         {
             //load textures for each layer (see Human textures folder in this repository)
             var skin = ModAPI.LoadTexture("Doctor.png");
             var flesh = ModAPI.LoadTexture("Cflesh.png");
             var bone = ModAPI.LoadTexture("bone layer.png");

             var person = Instance.GetComponent<PersonBehaviour>();

             var head = Instance.transform.Find("Head");
             var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
             var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
             var upper = Instance.transform.Find("Body").Find("UpperBody");
             var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
             var leg2 = Instance.transform.Find("BackLeg").Find("Foot");

             arm1.gameObject.AddComponent<Doctor>();
             arm2.gameObject.AddComponent<Doctor>();

             GameObject Mask = new GameObject();
             Mask.transform.parent = head;
             Mask.transform.localPosition = new Vector3(0.015f, -0.185f);
             Mask.transform.localScale = new Vector3(1f, 1f);

             var MaskSprite = Mask.AddComponent<SpriteRenderer>();

             MaskSprite.sprite = ModAPI.LoadSprite("Fragments/Mask.png");
             MaskSprite.sortingLayerName = "Top";


             foreach (var body in person.Limbs)
             {
                 body.BaseStrength += 5f;
                 body.Health *= 15f;
                 body.InitialHealth *= 14.5f;
                 body.ShotDamageMultiplier *= 0.2f;
                 body.BreakingThreshold += 11f;
                 body.RegenerationSpeed += 18f;
                 body.Vitality *= 18f;
                 body.ImpactPainMultiplier *= 0.5f;
                 body.Numbness *= 1f;
                 body.CirculationBehaviour.BloodFlow *= 150f;
                 body.IsZombie = true;
                 body.IsLethalToBreak = false;
                 body.gameObject.AddComponent<Zaura>();


             }

             //use the helper function to set each texture
             //parameters are as follows:
             //  skin texture, flesh texture, bone texture, sprite scale
             //you can pass "null" to fall back to the original texture
           person.SetBodyTextures(skin, flesh, bone, 1);
           person.SetBruiseColor(154, 205, 50); //main bruise colour. purple-ish by default
           person.SetSecondBruiseColor(128, 128, 0); //second bruise colour. red by default
           person.SetThirdBruiseColor(85, 107, 47); // third bruise colour. light yellow by default
           person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
           person.SetRottenColour(0, 0, 0);
         }
     }
 );



      //Zombie
     ModAPI.Register(
     new Modification()
     {
         OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
         NameOverride = "Zombie", //new item name with a suffix to assure it is globally unique
         DescriptionOverride = ""+"\n <color=orange>An unusual zombie that releases an infected gas invisible to the human eye from its body is devoid of any feelings. Which makes it unpredictable and dangerous. (Infects others when near an object).", //new item description
         CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
         ThumbnailOverride = ModAPI.LoadSprite("Zview.png"), //new item thumbnail (relative path)
         AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
         {
             //load textures for each layer (see Human textures folder in this repository)
             var skin = ModAPI.LoadTexture("Zombie.png");
             var flesh = ModAPI.LoadTexture("Zflesh.png");
             var bone = ModAPI.LoadTexture("Zbone.png");

             var person = Instance.GetComponent<PersonBehaviour>();

             var head = Instance.transform.Find("Head");
             var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
             var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
             var upper = Instance.transform.Find("Body").Find("UpperBody");
             var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
             var leg2 = Instance.transform.Find("BackLeg").Find("Foot");


             foreach (var body in person.Limbs)
             {
                 body.BaseStrength += 5f;
                 body.Health *= 15f;
                 body.InitialHealth *= 14.5f;
                 body.ShotDamageMultiplier *= 0.2f;
                 body.BreakingThreshold += 11f;
                 body.RegenerationSpeed += 18f;
                 body.Vitality *= 18f;
                 body.ImpactPainMultiplier *= 0.5f;
                 body.Numbness *= 1f;
                 body.CirculationBehaviour.BloodFlow *= 200f;
                 body.IsLethalToBreak = false;
                 body.IsZombie = true;
                 body.gameObject.AddComponent<Zaura>();


             }

             //use the helper function to set each texture
             //parameters are as follows:
             //  skin texture, flesh texture, bone texture, sprite scale
             //you can pass "null" to fall back to the original texture
           person.SetBodyTextures(skin, flesh, bone, 1);
           person.SetBruiseColor(154, 205, 50); //main bruise colour. purple-ish by default
           person.SetSecondBruiseColor(128, 128, 0); //second bruise colour. red by default
           person.SetThirdBruiseColor(85, 107, 47); // third bruise colour. light yellow by default
           person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
           person.SetRottenColour(0, 0, 0);
         }
     }
 );


       //hybrid
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Hybrid", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=yellow>A creature from another world, no one knows what it wants, came to people when they were in deep despair. But after talking to this creature, people changed, relatives said that they were replaced. Scientists interviewed people with whom this entity spoke, and they said that at some point they felt fear and relief. According to them, there were strange symbols on the creature's body. After a year of people telling everything, everyone went missing. And in their homes, a piece of paper was found on which it was written It was not necessary to do this. After that, no one wanted to talk to the scientists ...", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("HybridWive.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("gibrid.png");
              var flesh = ModAPI.LoadTexture("gibrid-flesh.png");
              var bone = ModAPI.LoadTexture("gibrid-skelet.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
              var leg2 = Instance.transform.Find("BackLeg").Find("Foot");

              head.gameObject.AddComponent<Hy>();
              upper.gameObject.AddComponent<Death2>();
              arm1.gameObject.AddComponent<Hy3>();
              arm2.gameObject.AddComponent<Hy2>();
              leg1.gameObject.AddComponent<Crush2>();
              leg2.gameObject.AddComponent<Hy4>();


              GameObject eye = new GameObject();
              eye.transform.parent = head;
              eye.transform.localPosition = new Vector3(-0.1f, -0.971f);
              eye.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = eye.AddComponent<SpriteRenderer>();

              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/hybridsprite2.png");
              eyeSprite.material = ModAPI.FindMaterial("VeryBright");
              eyeSprite.color = new Color(47f, 79f, 79f, 1f);
              eyeSprite.sortingLayerName = "Top";




              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 7f;
                  body.Health *= 60f;
                  body.InitialHealth *= 60f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 18f;
                  body.Vitality *= 18f;
                  body.ImpactPainMultiplier *= 0.5f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 20f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }

              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);
            person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
            person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
            person.SetRottenColour(0, 0, 0);
          }
      }
  );

  //Super Soldat
  ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
      NameOverride = "Super Soldier", //new item name with a suffix to assure it is globally unique
      DescriptionOverride = ""+"\n <color=orange>Unlike a cyborg, a super soldier has no robot parts, it has been genetically modified with immortality. He has no feelings, he only has a goal to fulfill a given mission. He was ready for this from birth.", //new item description
      CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
      ThumbnailOverride = ModAPI.LoadSprite("SPS-view.png"), //new item thumbnail (relative path)
      AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
      {
          //load textures for each layer (see Human textures folder in this repository)
          var skin = ModAPI.LoadTexture("superultramegasoldat 2.png");
          var flesh = ModAPI.LoadTexture("Cflesh.png");
          var bone = ModAPI.LoadTexture("bone layer.png");
          var leg1 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
          var leg2 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
          var leg3 = Instance.transform.Find("BackLeg").Find("LowerLeg");
          var leg4 = Instance.transform.Find("BackLeg").Find("UpperLeg");



          var person = Instance.GetComponent<PersonBehaviour>();

          var head = Instance.transform.Find("Head");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var upper = Instance.transform.Find("Body").Find("UpperBody");

          GameObject face = new GameObject();
          face.transform.parent = head;
          face.transform.localPosition = new Vector3(0.072f, 0f);
          face.transform.localScale = new Vector3(1f, 1f);

          var faceSprite = face.AddComponent<SpriteRenderer>();

          faceSprite.sprite = ModAPI.LoadSprite("Fragments/superultramegasoldat(HeadSpite).png");
          faceSprite.material = ModAPI.FindMaterial("VeryBright");
          faceSprite.color = new Color(0f, 206f, 209f, 0.043f);
          faceSprite.sortingLayerName = "Top";

          GameObject grud = new GameObject();
          grud.transform.parent = upper;
          grud.transform.localPosition = new Vector3(0.087f, -0.029f);
          grud.transform.localScale = new Vector3(1f, 1f);

          var grudSprite = grud.AddComponent<SpriteRenderer>();

          grudSprite.sprite = ModAPI.LoadSprite("Fragments/superultramegasoldat 2grud.png");
          grudSprite.material = ModAPI.FindMaterial("VeryBright");
          grudSprite.color = new Color(0f, 206f, 209f, 0.04f);
          grudSprite.sortingLayerName = "Top";

          GameObject ruka1 = new GameObject();
          ruka1.transform.parent = arm1;
          ruka1.transform.localPosition = new Vector3(0f, 0.129f);
          ruka1.transform.localScale = new Vector3(1f, 1f);

          var ruka1Sprite = ruka1.AddComponent<SpriteRenderer>();

          ruka1Sprite.sprite = ModAPI.LoadSprite("Fragments/superultramegasoldat(ArmSpite).png");
          ruka1Sprite.material = ModAPI.FindMaterial("VeryBright");
          ruka1Sprite.color = new Color(0f, 206f, 209f, 0.07f);
          ruka1Sprite.sortingLayerName = "Top";

          GameObject ruka2 = new GameObject();
          ruka2.transform.parent = arm2;
          ruka2.transform.localPosition = new Vector3(0f, 0.129f);
          ruka2.transform.localScale = new Vector3(1f, 1f);

          var ruka2Sprite = ruka2.AddComponent<SpriteRenderer>();

          ruka2Sprite.sprite = ModAPI.LoadSprite("Fragments/superultramegasoldat(ArmSpite).png");
          ruka2Sprite.material = ModAPI.FindMaterial("VeryBright");
          ruka2Sprite.color = new Color(0f, 206f, 209f, 0.07f);
          ruka2Sprite.sortingLayerName = "Top";

          GameObject ng1 = new GameObject();
          ng1.transform.parent = leg2;
          ng1.transform.localPosition = new Vector3(-0.03f, 0f);
          ng1.transform.localScale = new Vector3(1f, 1f);

          var ng1Sprite = ng1.AddComponent<SpriteRenderer>();

          ng1Sprite.sprite = ModAPI.LoadSprite("Fragments/superultramegasoldat(UpperLegSpite).png");
          ng1Sprite.material = ModAPI.FindMaterial("VeryBright");
          ng1Sprite.color = new Color(0f, 206f, 209f, 0.2f);
          ng1Sprite.sortingLayerName = "Top";

          GameObject ng2 = new GameObject();
          ng2.transform.parent = leg4;
          ng2.transform.localPosition = new Vector3(-0.03f, 0f);
          ng2.transform.localScale = new Vector3(1f, 1f);

          var ng2Sprite = ng2.AddComponent<SpriteRenderer>();

          ng2Sprite.sprite = ModAPI.LoadSprite("Fragments/superultramegasoldat(UpperLegSpite).png");
          ng2Sprite.material = ModAPI.FindMaterial("VeryBright");
          ng2Sprite.color = new Color(0f, 206f, 209f, 0.2f);
          ng2Sprite.sortingLayerName = "Top";

          GameObject ng3 = new GameObject();
          ng3.transform.parent = leg3;
          ng3.transform.localPosition = new Vector3(0f, -0.087f);
          ng3.transform.localScale = new Vector3(1f, 1f);

          var ng3Sprite = ng3.AddComponent<SpriteRenderer>();

          ng3Sprite.sprite = ModAPI.LoadSprite("Fragments/superultramegasoldat(LegSpite).png");
          ng3Sprite.material = ModAPI.FindMaterial("VeryBright");
          ng3Sprite.color = new Color(0f, 206f, 209f, 0.4f);
          ng3Sprite.sortingLayerName = "Top";

          GameObject ng4 = new GameObject();
          ng4.transform.parent = leg1;
          ng4.transform.localPosition = new Vector3(0f, -0.087f);
          ng4.transform.localScale = new Vector3(1f, 1f);

          var ng4Sprite = ng4.AddComponent<SpriteRenderer>();

          ng4Sprite.sprite = ModAPI.LoadSprite("Fragments/superultramegasoldat(LegSpite).png");
          ng4Sprite.material = ModAPI.FindMaterial("VeryBright");
          ng4Sprite.color = new Color(0f, 206f, 209f, 0.4f);
          ng4Sprite.sortingLayerName = "Top";

          arm1.gameObject.AddComponent<SPS>();
          arm2.gameObject.AddComponent<SPS>();



          foreach (var body in person.Limbs)
          {
              body.BaseStrength += 4f;
              body.Health *= 1500000000000000f;
              body.InitialHealth *= 1500000000000000f;
              body.ShotDamageMultiplier *= 0.2f;
              body.BreakingThreshold += 100f;
              body.RegenerationSpeed += 1500000000000000f;
              body.Vitality *= 5f;
              body.ImpactPainMultiplier *= 0.2f;
              body.Numbness *= 1f;
              body.CirculationBehaviour.BloodFlow *= 350f;
              body.IsLethalToBreak = false;
              body.transform.root.localScale *= 1.01f;
              body.gameObject.AddComponent<DG>();
              body.gameObject.AddComponent<udp2>();
          }

          //use the helper function to set each texture
          //parameters are as follows:
          //  skin texture, flesh texture, bone texture, sprite scale
          //you can pass "null" to fall back to the original texture
          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
          person.SetSecondBruiseColor(170, 0, 0); //second bruise colour. red by default
          person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
          person.SetBloodColour(140, 0, 0); // blood clour. dark red by default
          person.SetRottenColour(0, 0, 0);
      }
   }
);


  //Mr X
  ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
      NameOverride = "Mr.X", //new item name with a suffix to assure it is globally unique
      DescriptionOverride = ""+"\n <color=orange>This is a subspecies of the line of super soldiers, created by the Umbrella Corporation under the code name (Tyrant), possessing superhuman strength. If he is given a task, then he will pursue the goal to the last, until he completes the task (if he hits with his hand, he will throw his enemy back and break his bones. If the tyrant hits him with his head, he will open a part of the enemy's body).", //new item description
      CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
      ThumbnailOverride = ModAPI.LoadSprite("MR_XView.png"), //new item thumbnail (relative path)
      AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
      {
          //load textures for each layer (see Human textures folder in this repository)
          var skin = ModAPI.LoadTexture("MR_X.png");
          var flesh = ModAPI.LoadTexture("Cflesh.png");
          var bone = ModAPI.LoadTexture("bone layer.png");
          var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
          var leg2 = Instance.transform.Find("BackLeg").Find("Foot");


          var person = Instance.GetComponent<PersonBehaviour>();

          var head = Instance.transform.Find("Head");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var upper = Instance.transform.Find("Body").Find("UpperBody");
          head.gameObject.AddComponent<Hy>();
          arm1.gameObject.AddComponent<MR_X>();
          arm2.gameObject.AddComponent<MR_X>();
          leg1.gameObject.AddComponent<MR_X>();
          leg2.gameObject.AddComponent<MR_X>();


          GameObject eye = new GameObject();
          eye.transform.parent = head;
          eye.transform.localPosition = new Vector3(-0.071f, -0.971f);
          eye.transform.localScale = new Vector3(1f, 1f);

          var eyeSprite = eye.AddComponent<SpriteRenderer>();

          eyeSprite.sprite = ModAPI.LoadSprite("Fragments/MR_Xeye.png");
          eyeSprite.sortingLayerName = "Top";
          eyeSprite.material = ModAPI.FindMaterial("VeryBright");
          eyeSprite.color = new Color(255f, 99f, 71f, 0.15f);

          GameObject hat = new GameObject();
          hat.transform.parent = head;
          hat.transform.localPosition = new Vector3(0f, 0.08f);
          hat.transform.localScale = new Vector3(1f, 1f);

          var hatSprite = hat.AddComponent<SpriteRenderer>();

          hatSprite.sprite = ModAPI.LoadSprite("Fragments/hat2.png");
          hatSprite.sortingLayerName = "Top";

          foreach (var body in person.Limbs)
          {
              body.BaseStrength += 10f;
              body.Health *= 150f;
              body.InitialHealth *= 150f;
              body.ShotDamageMultiplier *= 0.2f;
              body.BreakingThreshold += 100f;
              body.RegenerationSpeed += 50f;
              body.Vitality *= 100f;
              body.ImpactPainMultiplier *= 0.2f;
              body.Numbness *= 1f;
              body.CirculationBehaviour.BloodFlow *= 350f;
              body.IsLethalToBreak = false;
              body.transform.root.localScale *= 1.01f;
              body.gameObject.AddComponent<DG>();
              body.gameObject.AddComponent<udp2>();
          }

          //use the helper function to set each texture
          //parameters are as follows:
          //  skin texture, flesh texture, bone texture, sprite scale
          //you can pass "null" to fall back to the original texture
          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
          person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
          person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
          person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
          person.SetRottenColour(0, 0, 0);
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 50f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 50f;
          Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 50f;
      }
  }
);



            //Golem
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Golem", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = "" + "\n <color=green>An ancient creature that was created to help in battles, in the household and for other purposes. An old and cracked golem that has gone through many battles, but still works...", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Golem_view.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
                    var skin = ModAPI.LoadTexture("Golem_Concept.png");
                    var flesh = ModAPI.LoadTexture("Cflesh.png");
                    var bone = ModAPI.LoadTexture("bone layer.png");

                    var person = Instance.GetComponent<PersonBehaviour>();

                    var head = Instance.transform.Find("Head");
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                    var upper = Instance.transform.Find("Body").Find("UpperBody");
                    arm1.gameObject.AddComponent<Golem>();
                    arm2.gameObject.AddComponent<Golem>();

                    GameObject eye = new GameObject();
                    eye.transform.parent = head;
                    eye.transform.localPosition = new Vector3(-0.071f, -0.971f);
                    eye.transform.localScale = new Vector3(1f, 1f);

                    var eyeSprite = eye.AddComponent<SpriteRenderer>();

                    eyeSprite.sprite = ModAPI.LoadSprite("Fragments/Golem_eye.png");
                    eyeSprite.sortingLayerName = "Top";
                    eyeSprite.material = ModAPI.FindMaterial("VeryBright");
                    eyeSprite.color = new Color(61f, 30f, 73f, 0.35f);

                    foreach (var body in person.Limbs)
                    {
                        body.BaseStrength += 180f;
                        body.Health *= 45000000000f;
                        body.InitialHealth *= 45000000000f;
                        body.ShotDamageMultiplier *= 0.1f;
                        body.BreakingThreshold += 40f;
                        body.RegenerationSpeed += 45000000000f;
                        body.Vitality *= 1f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 1f;
                        body.CirculationBehaviour.BloodFlow *= 45000000000f;
                        body.IsLethalToBreak = false;
                        body.transform.root.localScale *= 1.122f;
                        body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");
                        body.transform.localScale = new Vector3(1f, 1f);
                        body.IsAndroid = true;
                        body.gameObject.AddComponent<DG>();
                        body.gameObject.AddComponent<BreakeBone2>();

                    }

              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
                    person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(192, 192, 192); //second bruise colour. red by default
              person.SetThirdBruiseColor(169, 169, 169); // third bruise colour. light yellow by default
              person.SetBloodColour(128, 128, 128); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
                }
            }
        );




            //Stone man
            ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Stone man", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=green>Travelers found an unconscious man in the wilderness, he was all covered with stone growth and moss. After the man woke up, he said that he went on an adventure in order to get rid of a stone build-up.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Rock_view.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("RockHuman.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("bone layer.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              arm1.gameObject.AddComponent<StoneBehaviour>();
              arm2.gameObject.AddComponent<StoneBehaviour>();

              GameObject eye = new GameObject();
              eye.transform.parent = head;
              eye.transform.localPosition = new Vector3(-0.071f, -0.971f);
              eye.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = eye.AddComponent<SpriteRenderer>();

              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/Rockeye.png");
              eyeSprite.sortingLayerName = "Top";
              eyeSprite.material = ModAPI.FindMaterial("VeryBright");
              eyeSprite.color = new Color(127f, 255f, 0f, 0.35f);

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 7.5f;
                  body.Health *= 45f;
                  body.InitialHealth *= 3.4f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 20f;
                  body.RegenerationSpeed += 18f;
                  body.Vitality *= 100f;
                  body.ImpactPainMultiplier *= 0.2f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 500f;
                  body.IsLethalToBreak = false;
                  body.transform.root.localScale *= 1.02f;
                  body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");
                  body.transform.root.localScale *= 0.99f;
                  body.gameObject.AddComponent<DG>();
                  body.gameObject.AddComponent<BreakeBone2>();

              }

              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(	105, 105, 105); //second bruise colour. red by default
              person.SetThirdBruiseColor(100, 100, 100); // third bruise colour. light yellow by default
              person.SetBloodColour(50, 50, 50); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );

      //Marionetka
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Puppet", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=red>The frightening creature with a blank stare was called a puppet by the locals. He was just as lifeless, with a blank stare and a frightening smile, but he could hear people. After that, the people of the village died from the explosion. Law enforcement officials said that a gas cylinder allegedly exploded in this village. You can activate any part of the body, after activation, this part will explode.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Marview.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("Marionetka2.png");
              var flesh = ModAPI.LoadTexture("Marionetka2.png");
              var bone = ModAPI.LoadTexture("Mbone.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
              var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
              arm1.gameObject.AddComponent<Booom>();
              arm2.gameObject.AddComponent<Booom>();
              leg1.gameObject.AddComponent<Booom>();
              leg2.gameObject.AddComponent<Booom>();

              GameObject eye = new GameObject();
              eye.transform.parent = head;
              eye.transform.localPosition = new Vector3(-0.071f, -0.971f);
              eye.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = eye.AddComponent<SpriteRenderer>();

              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/m2eye.png");
              eyeSprite.sortingLayerName = "Top";
              eyeSprite.material = ModAPI.FindMaterial("VeryBright");
              eyeSprite.color = new Color(199f, 21f, 133f, 0.15f);

              GameObject rt = new GameObject();
              rt.transform.parent = head;
              rt.transform.localPosition = new Vector3(-0.071f, -0.97f);
              rt.transform.localScale = new Vector3(1f, 1f);

              var rtSprite = rt.AddComponent<SpriteRenderer>();

              rtSprite.sprite = ModAPI.LoadSprite("Fragments/m2rt.png");
              rtSprite.sortingLayerName = "Top";
              rtSprite.material = ModAPI.FindMaterial("VeryBright");
              rtSprite.color = new Color(199f, 21f, 133f, 0.15f);

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 3.5f;
                  body.Health *= 3.45f;
                  body.InitialHealth *= 2.9f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 12f;
                  body.RegenerationSpeed += 12.5f;
                  body.Vitality *= 7f;
                  body.ImpactPainMultiplier *= 0f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 6f;
                  body.IsLethalToBreak = false;
                  body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                  body.gameObject.AddComponent<Booom>();
                  body.gameObject.AddComponent<DG>();

              }

              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );




      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Mysterious masked man", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=yellow>According to the stories of people who saw him, they said that this man was unbalanced, and saw how he tore off a man's skin with his bare hands. The police never found him, but few know the truth, and those who know are no longer alive. The police first tried to find out who it was. But this person is not in the database, so he was added to the list of non-existent people. Leaves only meat when touched.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Mview.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("Miasnik.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("bone layer.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              arm1.gameObject.AddComponent<Miasnik>();
              arm2.gameObject.AddComponent<Miasnik>();

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 3.5f;
                  body.Health *= 3.2f;
                  body.InitialHealth *= 2.7f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 12f;
                  body.RegenerationSpeed += 12.5f;
                  body.Vitality *= 4.5f;
                  body.ImpactPainMultiplier *= 0.5f;
                  body.Numbness *= 3f;
                  body.CirculationBehaviour.BloodFlow *= 4f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }


      //use the helper function to set each texture
      //parameters are as follows:
      //  skin texture, flesh texture, bone texture, sprite scale
      //you can pass "null" to fall back to the original texture
      person.SetBodyTextures(skin, flesh, bone, 1);
      person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
      person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
      person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
      person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
      person.SetRottenColour(0, 0, 0);
    }
  }
);

//glasssman
ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
    NameOverride = "Glass man", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = ""+"\n <color=red>A glass creature capable of reflecting lasers. Also remove parts of the enemy's body with your sharp glass hands.", //new item description
    CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("glassmanview.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //load textures for each layer (see Human textures folder in this repository)
        var skin = ModAPI.LoadTexture("stekloman.png");
        var flesh = ModAPI.LoadTexture("stekloman.png");
        var bone = ModAPI.LoadTexture("bone layer.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        var head = Instance.transform.Find("Head");
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
        var upper = Instance.transform.Find("Body").Find("UpperBody");
        arm1.gameObject.AddComponent<GS2>();
        arm2.gameObject.AddComponent<GS2>();


        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 5.5f;
            body.Health *= 5.2f;
            body.InitialHealth *= 5.2f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 12f;
            body.RegenerationSpeed += 12.5f;
            body.Vitality *= 4.5f;
            body.ImpactPainMultiplier *= 0.5f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.gameObject.AddComponent<DG>();
            body.PhysicalBehaviour.ReflectsLasers = true;
            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Glass");

        }

        person.SetBodyTextures(skin, flesh, bone, 1);
        person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
        person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
        person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
        person.SetRottenColour(0, 0, 0);
      }
    }
  );

  //evil spirit
  ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
      NameOverride = "Evil Spirit", //new item name with a suffix to assure it is globally unique
      DescriptionOverride = ""+"\n <color=red>An evil spirit, which only thirsts for murder, avenges his death, only he has already avenged, and that was 20 years ago, but anger is still raging in him ... (His sharp hands can pierce the body)", //new item description
      CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
      ThumbnailOverride = ModAPI.LoadSprite("spiritviwe.png"), //new item thumbnail (relative path)
      AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
      {
          //load textures for each layer (see Human textures folder in this repository)
          var skin = ModAPI.LoadTexture("Bad Ghost.png");
          var flesh = ModAPI.LoadTexture("Bad Ghost.png");
          var bone = ModAPI.LoadTexture("Bad Ghost.png");

          var person = Instance.GetComponent<PersonBehaviour>();

          var head = Instance.transform.Find("Head");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var upper = Instance.transform.Find("Body").Find("UpperBody");

          var component = arm1.GetComponent<PhysicalBehaviour>();
          var chelovek = ModAPI.FindPhysicalProperties("Human");
          chelovek.Sharp = true;
          chelovek.SharpAxes = new[]
          {
                                  new SharpAxis(Vector2.down, 0f, 0.55f, false, true),
                              };
          component.Properties = chelovek;
          var component2 = arm2.GetComponent<PhysicalBehaviour>();
          component2.Properties = chelovek;

          GameObject eye = new GameObject();
          eye.transform.parent = head;
          eye.transform.localPosition = new Vector3(-0.1f, -0.971f);
          eye.transform.localScale = new Vector3(1f, 1f);

          var eyeSprite = eye.AddComponent<SpriteRenderer>();

          eyeSprite.sprite = ModAPI.LoadSprite("Fragments/spiriteye.png");
          eyeSprite.material = ModAPI.FindMaterial("VeryBright");
          eyeSprite.color = new Color(170f, 0f, 0f, 0.20f);



          foreach (var body in person.Limbs)
          {
            body.BaseStrength *= 0.25f;
            body.IsLethalToBreak = false;
            body.Health *= 7.5f;
            body.InitialHealth *= 7f;
            body.BreakingThreshold += 12f;
            body.RegenerationSpeed += 14.5f;
            body.Vitality *= 8f;
            body.CirculationBehaviour.BloodFlow *= 7f;
            body.PhysicalBehaviour.MakeWeightless();
            body.gameObject.layer = 9;
            body.gameObject.AddComponent<DG>();


          }

          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(110, 0, 0); //main bruise colour. purple-ish by default
          person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
          person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
          person.SetBloodColour(224, 255, 255); // blood clour. dark red by default
          person.SetRottenColour(0, 0, 0);
        }
      }
  );


//cyborg
ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
    NameOverride = "Cyborg", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = ""+"\n <color=red>Secret development of an unknown company. Very strong humanoid robot.", //new item description
    CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("Cyborg_view.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //load textures for each layer (see Human textures folder in this repository)
        var skin = ModAPI.LoadTexture("Cyborg.png");
        var flesh = ModAPI.LoadTexture("Cyborg.png");
        var bone = ModAPI.LoadTexture("Cyrbone.png");

        var person = Instance.GetComponent<PersonBehaviour>();

        var head = Instance.transform.Find("Head");
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
        var upper = Instance.transform.Find("Body").Find("UpperBody");
        var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
        var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
        GameObject halo = new GameObject();
        halo.transform.parent = head;
        halo.transform.localPosition = new Vector3(-0.072f, -0.971f);
        halo.transform.localScale = new Vector3(1f, 1f);

        var eyeSprite = halo.AddComponent<SpriteRenderer>();

        eyeSprite.sprite = ModAPI.LoadSprite("Fragments/Cyborg_eye.png");
        eyeSprite.material = ModAPI.FindMaterial("VeryBright");
        eyeSprite.color = new Color(0f, 255f, 255f, 0.15f);
        eyeSprite.sortingLayerName = "Top";
        arm1.gameObject.AddComponent<СyberBehaviour>();
        arm2.gameObject.AddComponent<СyberBehaviour>();
        leg1.gameObject.AddComponent<Cyberfoot>();
        leg2.gameObject.AddComponent<Cyberfoot>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 5f;
            body.Health *= 3.7f;
            body.InitialHealth *= 2.9f;
            body.ShotDamageMultiplier *= -1f;
            body.BreakingThreshold += 11f;
            body.RegenerationSpeed += 15.5f;
            body.Vitality *= 6f;
            body.ImpactPainMultiplier *= 0f;
            body.Numbness *= 1f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.gameObject.AddComponent<DG>();

        }



        //use the helper function to set each texture
        //parameters are as follows:
        //  skin texture, flesh texture, bone texture, sprite scale
        //you can pass "null" to fall back to the original texture
        person.SetBodyTextures(skin, flesh, bone, 1);
    }
}
);

      //frank
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Frankenstein", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=red>Frankenstein's famous monster. Kills body parts when touched.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Frankview.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("Frankinstein.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("Frankbone.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              GameObject halo = new GameObject();
              halo.transform.parent = head;
              halo.transform.localPosition = new Vector3(-0.045f, -1f);
              halo.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = halo.AddComponent<SpriteRenderer>();

              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/frank_eye.png");
              eyeSprite.material = ModAPI.FindMaterial("VeryBright");
              eyeSprite.color = new Color(0f, 255f, 127f, 0.30f);
              eyeSprite.sortingLayerName = "Top";
              arm1.gameObject.AddComponent<Frank>();
              arm2.gameObject.AddComponent<Frank>();

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 8f;
                  body.Health *= 3.7f;
                  body.InitialHealth *= 2.9f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 13.5f;
                  body.Vitality *= 6f;
                  body.ImpactPainMultiplier *= 0.5f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 4f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }

              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );

      // Evilsanta
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Evil Santa", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=red>An Evil Santa who wants to spoil the spirit of Christmas. A double of a real Santa, but evil. Freezes when touched.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("SantaView.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("evilsanta.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("bone layer.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              GameObject halo = new GameObject();
              halo.transform.parent = head;
              halo.transform.localPosition = new Vector3(-0.071f, -0.971f);
              halo.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = halo.AddComponent<SpriteRenderer>();
              arm1.gameObject.AddComponent<evilsanta>();
              arm2.gameObject.AddComponent<evilsanta>();

              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/evilsanta_eye.png");
              eyeSprite.material = ModAPI.FindMaterial("VeryBright");
              eyeSprite.color = new Color(255f, 0f, 0f, 1f);
              eyeSprite.sortingLayerName = "Top";

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 3f;
                  body.Health *= 3.4f;
                  body.InitialHealth *= 2.8f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 13f;
                  body.Vitality *= 4f;
                  body.ImpactPainMultiplier *= 0.5f;
                  body.Numbness *= 3f;
                  body.CirculationBehaviour.BloodFlow *= 4f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }



              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );

      //werewolf
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "werewolf", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=yellow>A person who owns lycanthropy is neutral towards people. Transformed into a werewolf, but with a preserved sanity.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("OBview.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("werewolf.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("bone layer.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");

              GameObject dglaz = new GameObject();
              dglaz.transform.parent = head;
              dglaz.transform.localPosition = new Vector3(-0.072f, -0.971f);
              dglaz.transform.localScale = new Vector3(1f, 1f);

              var glazSprite = dglaz.AddComponent<SpriteRenderer>();
              arm1.gameObject.AddComponent<werewolf>();
              arm2.gameObject.AddComponent<werewolf>();

              glazSprite.sprite = ModAPI.LoadSprite("Fragments/werewolfeye.png");
              glazSprite.material = ModAPI.FindMaterial("VeryBright");
              glazSprite.color = new Color(255f, 69f, 0f, 0.28f);
              glazSprite.sortingLayerName = "Top";

              GameObject chasti = new GameObject();
              chasti.transform.parent = head;
              chasti.transform.localPosition = new Vector3(-0.0143f, -0.971f);
              chasti.transform.localScale = new Vector3(1f, 1f);

              var chastSprite = chasti.AddComponent<SpriteRenderer>();

              chastSprite.sprite = ModAPI.LoadSprite("Fragments/wirewolf fragment.png");
              chastSprite.sortingLayerName = "Top";

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 4f;
                  body.Health *= 3.9f;
                  body.InitialHealth *= 3.0f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 14f;
                  body.Vitality *= 3f;
                  body.ImpactPainMultiplier *= 0.5f;
                  body.Numbness *= 3f;
                  body.CirculationBehaviour.BloodFlow *= 4.5f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }



              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );

      // Angel of Death
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Angel of Death", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=orange>The Angel of Death, his goal is to lead souls, separated from the body, into another world. When touched, it kills all body tissues except the human skeleton.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Angel of Deathview.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("Death_Angel.png");
              var flesh = ModAPI.LoadTexture("bone layer.png");
              var bone = ModAPI.LoadTexture("bone layer.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              GameObject halo = new GameObject();
              halo.transform.parent = upper;
              halo.transform.localPosition = new Vector3(-0.56f, 0.1f);
              halo.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = halo.AddComponent<SpriteRenderer>();
              arm1.gameObject.AddComponent<Death>();
              arm2.gameObject.AddComponent<Death>();

              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/Black_AWings.png", 7f);
              eyeSprite.sortingLayerName = "Top";

              GameObject nimb = new GameObject();
              nimb.transform.parent = head;
              nimb.transform.localPosition = new Vector3(0f, 0f);
              nimb.transform.localScale = new Vector3(1f, 1f);

              var nimbSprite = nimb.AddComponent<SpriteRenderer>();

              nimbSprite.sprite = ModAPI.LoadSprite("Fragments/Nimb.png");
              nimbSprite.material = ModAPI.FindMaterial("VeryBright");
              nimbSprite.color = new Color(255f, 215f, 0f, 0.13f);
              nimbSprite.sortingLayerName = "Top";

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 2f;
                  body.Health *= 3.6f;
                  body.InitialHealth *= 2.9f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 10f;
                  body.RegenerationSpeed += 12f;
                  body.Vitality *= 8.5f;
                  body.ImpactPainMultiplier *= 0.2f;
                  body.Numbness *= 3f;
                  body.CirculationBehaviour.BloodFlow *= 4f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();
                  body.gameObject.AddComponent<udp2>();

              }



              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );

  //Cursed Lord
  ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
      NameOverride = "Cursed Lord", //new item name with a suffix to assure it is globally unique
      DescriptionOverride = "The damned lord was an ordinary person, though not very good. He was bloodthirsty and only lived in battles, when he killed all his enemies, he heard about the ancient creature. Then he went to look for him, and when he found him he wanted to fight him. But the creature ignored him. Then he went against him, But in an instant he felt a heat inside him. The creature cursed him, his skin and entrails burnt, leaving only a charred skeleton. However, the curse prevented him from dying. To this day, he feels this pain.", //new item description
      CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
      ThumbnailOverride = ModAPI.LoadSprite("CL_View.png"), //new item thumbnail (relative path)
      AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
      {
          //load textures for each layer (see Human textures folder in this repository)
          var skin = ModAPI.LoadTexture("Black_knight_bones_END.png");
          var flesh = ModAPI.LoadTexture("Black_knight_bones_END.png");
          var bone = ModAPI.LoadTexture("Black_knight_bones_END.png");

          var person = Instance.GetComponent<PersonBehaviour>();

          var head = Instance.transform.Find("Head");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var upper = Instance.transform.Find("Body").Find("UpperBody");
          var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
          var leg2 = Instance.transform.Find("BackLeg").Find("Foot");

          arm1.gameObject.AddComponent<GunBeh4>();
          arm2.gameObject.AddComponent<GunBeh4>();

          GameObject eye = new GameObject();
          eye.transform.parent = head;
          eye.transform.localPosition = new Vector3(-0.1f, -0.97f);
          eye.transform.localScale = new Vector3(1f, 1f);

          var eyeSprite = eye.AddComponent<SpriteRenderer>();

          eyeSprite.sprite = ModAPI.LoadSprite("Fragments/CureEye.png");
          eyeSprite.material = ModAPI.FindMaterial("VeryBright");
          eyeSprite.color = new Color(69f, 22f, 28f, 0.09f);


          foreach (var body in person.Limbs)
          {
              body.BaseStrength += 6.5f;
              body.Health *= 3.8f;
              body.InitialHealth *= 2.9f;
              body.ShotDamageMultiplier *= 0.2f;
              body.BreakingThreshold += 12f;
              body.RegenerationSpeed += 14.5f;
              body.Vitality *= 7f;
              body.ImpactPainMultiplier *= 0f;
              body.Numbness *= 1f;
              body.CirculationBehaviour.BloodFlow *= 6f;
              body.IsLethalToBreak = false;
              body.gameObject.AddComponent<udp2>();
              body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
              body.gameObject.AddComponent<DG>();

          }

          //use the helper function to set each texture
          //parameters are as follows:
          //  skin texture, flesh texture, bone texture, sprite scale
          //you can pass "null" to fall back to the original texture
          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
          person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
          person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
          person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
          person.SetRottenColour(0, 0, 0);
      }
   }
);

  //Cursed Monk
  ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
      NameOverride = "Cursed Monk", //new item name with a suffix to assure it is globally unique
      DescriptionOverride = ""+"\n <color=red>Risen dead monk. Possesses dark magic.", //new item description
      CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
      ThumbnailOverride = ModAPI.LoadSprite("Monk_View2.png"), //new item thumbnail (relative path)
      AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
      {
          //load textures for each layer (see Human textures folder in this repository)
          var skin = ModAPI.LoadTexture("magic_skelet.png");
          var flesh = ModAPI.LoadTexture("magic_skelet.png");
          var bone = ModAPI.LoadTexture("magic_skelet.png");

          var person = Instance.GetComponent<PersonBehaviour>();

          var head = Instance.transform.Find("Head");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var upper = Instance.transform.Find("Body").Find("UpperBody");
          var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
          var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
          arm1.gameObject.AddComponent<GunBeh5>();
          arm2.gameObject.AddComponent<GunBeh5>();

          GameObject eye = new GameObject();
          eye.transform.parent = head;
          eye.transform.localPosition = new Vector3(-0.1f, -0.971f);
          eye.transform.localScale = new Vector3(1f, 1f);

          var eyeSprite = eye.AddComponent<SpriteRenderer>();

          eyeSprite.sprite = ModAPI.LoadSprite("Fragments/nonameGlaz2.png");
          eyeSprite.material = ModAPI.FindMaterial("VeryBright");
          eyeSprite.color = new Color(230f, 230f, 250f, 0.20f);


          foreach (var body in person.Limbs)
          {
              body.BaseStrength += 6.5f;
              body.Health *= 3.8f;
              body.InitialHealth *= 2.9f;
              body.ShotDamageMultiplier *= 0.2f;
              body.BreakingThreshold += 12f;
              body.RegenerationSpeed += 14.5f;
              body.Vitality *= 7f;
              body.ImpactPainMultiplier *= 0f;
              body.Numbness *= 1f;
              body.CirculationBehaviour.BloodFlow *= 6f;
              body.IsLethalToBreak = false;
              body.gameObject.AddComponent<udp2>();
              body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 1f;
              body.gameObject.AddComponent<DG>();

          }

          //use the helper function to set each texture
          //parameters are as follows:
          //  skin texture, flesh texture, bone texture, sprite scale
          //you can pass "null" to fall back to the original texture
          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
          person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
          person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
          person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
          person.SetRottenColour(0, 0, 0);
      }
   }
);

  //an object named phantom 2
  ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
      NameOverride = "an object named phantomn 2", //new item name with a suffix to assure it is globally unique
      DescriptionOverride = ""+"\n <color=orange>Object 224, created by the same scientist as Object 223, is devoid of all feelings and desire to kill oneself, unlike Object 223, Object 224 has immortality. Which led to the destruction of the city where the mad scientist lived. After a long time, Object 224 wandered through the ruins of the destroyed city, emitting a heart-rending cry.", //new item description
      CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
      ThumbnailOverride = ModAPI.LoadSprite("udp2_view.png"), //new item thumbnail (relative path)
      AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
      {
          //load textures for each layer (see Human textures folder in this repository)
          var skin = ModAPI.LoadTexture("noname4.png");
          var flesh = ModAPI.LoadTexture("noname4.png");
          var bone = ModAPI.LoadTexture("noname4.png");

          var person = Instance.GetComponent<PersonBehaviour>();

          var head = Instance.transform.Find("Head");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var upper = Instance.transform.Find("Body").Find("UpperBody");
          var leg1 = Instance.transform.Find("FrontLeg").Find("FootFront");
          var leg2 = Instance.transform.Find("BackLeg").Find("Foot");
          arm1.gameObject.AddComponent<udp3>();
          arm2.gameObject.AddComponent<udp3>();
          leg1.gameObject.AddComponent<Kfoot>();
          leg2.gameObject.AddComponent<Kfoot>();

          GameObject eye = new GameObject();
          eye.transform.parent = head;
          eye.transform.localPosition = new Vector3(-0.1f, -0.97f);
          eye.transform.localScale = new Vector3(1f, 1f);

          var eyeSprite = eye.AddComponent<SpriteRenderer>();

          eyeSprite.sprite = ModAPI.LoadSprite("Fragments/nonameGlaz2.png");
          eyeSprite.material = ModAPI.FindMaterial("VeryBright");
          eyeSprite.color = new Color(0f, 255f, 255f, 0.20f);


          foreach (var body in person.Limbs)
          {
              body.BaseStrength += 6.5f;
              body.Health *= 3.8f;
              body.InitialHealth *= 2.9f;
              body.ShotDamageMultiplier *= 0.2f;
              body.BreakingThreshold += 12f;
              body.RegenerationSpeed += 14.5f;
              body.Vitality *= 7f;
              body.ImpactPainMultiplier *= 0f;
              body.Numbness *= 1f;
              body.CirculationBehaviour.BloodFlow *= 6f;
              body.IsLethalToBreak = false;
              body.gameObject.AddComponent<udp2>();
              body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
              body.gameObject.AddComponent<DG>();

          }

          //use the helper function to set each texture
          //parameters are as follows:
          //  skin texture, flesh texture, bone texture, sprite scale
          //you can pass "null" to fall back to the original texture
          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
          person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
          person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
          person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
          person.SetRottenColour(0, 0, 0);
      }
   }
);



  //an object named phantom 1
  ModAPI.Register(
  new Modification()
  {
      OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
      NameOverride = "an object named phantom 1", //new item name with a suffix to assure it is globally unique
      DescriptionOverride = ""+"\n <color=orange>Object 223, created by a mad scientist. has a complex character and a strong desire to kill himself and take as many offenders with him as possible.", //new item description
      CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
      ThumbnailOverride = ModAPI.LoadSprite("udp_view.png"), //new item thumbnail (relative path)
      AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
      {
          //load textures for each layer (see Human textures folder in this repository)
          var skin = ModAPI.LoadTexture("noname3.png");
          var flesh = ModAPI.LoadTexture("noname3.png");
          var bone = ModAPI.LoadTexture("noname3.png");

          var person = Instance.GetComponent<PersonBehaviour>();

          var head = Instance.transform.Find("Head");
          var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
          var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
          var upper = Instance.transform.Find("Body").Find("UpperBody");
          arm1.gameObject.AddComponent<udp>();
          arm2.gameObject.AddComponent<udp>();

          GameObject eye = new GameObject();
          eye.transform.parent = head;
          eye.transform.localPosition = new Vector3(-0.1f, -0.97f);
          eye.transform.localScale = new Vector3(1f, 1f);

          var eyeSprite = eye.AddComponent<SpriteRenderer>();

          eyeSprite.sprite = ModAPI.LoadSprite("Fragments/nonameGlaz.png");
          eyeSprite.material = ModAPI.FindMaterial("VeryBright");
          eyeSprite.color = new Color(0f, 255f, 255f, 0.20f);


          foreach (var body in person.Limbs)
          {
              body.BaseStrength += 6.5f;
              body.Health *= 3.8f;
              body.InitialHealth *= 2.9f;
              body.ShotDamageMultiplier *= 0.2f;
              body.BreakingThreshold += 12f;
              body.RegenerationSpeed += 14.5f;
              body.Vitality *= 7f;
              body.ImpactPainMultiplier *= 0f;
              body.Numbness *= 1f;
              body.CirculationBehaviour.BloodFlow *= 6f;
              body.IsLethalToBreak = false;
              body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
              body.gameObject.AddComponent<DG>();

          }

          //use the helper function to set each texture
          //parameters are as follows:
          //  skin texture, flesh texture, bone texture, sprite scale
          //you can pass "null" to fall back to the original texture
          person.SetBodyTextures(skin, flesh, bone, 1);
          person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
          person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
          person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
          person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
          person.SetRottenColour(0, 0, 0);
      }
  }
);

      // Angel
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Angel", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=green>A spiritual, disembodied being, has supernatural powers.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Angelview.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("Angel.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("bone layer.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              GameObject halo = new GameObject();
              halo.transform.parent = upper;
              halo.transform.localPosition = new Vector3(-0.58f, 0.1f);
              halo.transform.localScale = new Vector3(1f, 1f);

              var eyeSprite = halo.AddComponent<SpriteRenderer>();
              arm1.gameObject.AddComponent<Heal>();
              arm2.gameObject.AddComponent<Heal>();

              eyeSprite.sprite = ModAPI.LoadSprite("Fragments/AWings.png", 7f);
              eyeSprite.sortingLayerName = "Top";

              GameObject nimb = new GameObject();
              nimb.transform.parent = head;
              nimb.transform.localPosition = new Vector3(0f, 0f);
              nimb.transform.localScale = new Vector3(1f, 1f);

              var nimbSprite = nimb.AddComponent<SpriteRenderer>();

              nimbSprite.sprite = ModAPI.LoadSprite("Fragments/Nimb.png");
              nimbSprite.material = ModAPI.FindMaterial("VeryBright");
              nimbSprite.color = new Color(255f, 215f, 0f, 0.18f);
              nimbSprite.sortingLayerName = "Top";

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 4f;
                  body.Health *= 2.6f;
                  body.InitialHealth *= 2.6f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 13f;
                  body.RegenerationSpeed += 15f;
                  body.Vitality *= 7f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 3f;
                  body.CirculationBehaviour.BloodFlow *= 3.5f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }



              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );

      //Demon
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Demon", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=yellow>An evil creature that tells people with sweet lies, but kills in the end. Breaks bone when touched.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Demonview.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("SeenlesDemons.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("skeletdemon.png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");

              GameObject horn = new GameObject();
              horn.transform.parent = head;
              horn.transform.localPosition = new Vector3(0f, -0.1f);
              horn.transform.localScale = new Vector3(1f, 1f);

              var hornSprite = horn.AddComponent<SpriteRenderer>();
              arm1.gameObject.AddComponent<BreakeBone>();
              arm2.gameObject.AddComponent<BreakeBone>();

              hornSprite.sprite = ModAPI.LoadSprite("Fragments/Dhorn.png");
              hornSprite.sortingLayerName = "Top";

              GameObject dglaz = new GameObject();
              dglaz.transform.parent = head;
              dglaz.transform.localPosition = new Vector3(0f, 0f);
              dglaz.transform.localScale = new Vector3(1f, 1f);

              var glazSprite = dglaz.AddComponent<SpriteRenderer>();
              arm1.gameObject.AddComponent<Crush>();
              arm2.gameObject.AddComponent<Crush>();

              glazSprite.sprite = ModAPI.LoadSprite("Fragments/Eye2.png");
              glazSprite.material = ModAPI.FindMaterial("VeryBright");
              glazSprite.color = new Color(255f, 215f, 0f, 0.15f);
              glazSprite.sortingLayerName = "Top";

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 5f;
                  body.Health *= 3.7f;
                  body.InitialHealth *= 2.8f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 10f;
                  body.RegenerationSpeed += 14f;
                  body.Vitality *= 5f;
                  body.ImpactPainMultiplier *= 0.2f;
                  body.Numbness *= 3f;
                  body.CirculationBehaviour.BloodFlow *= 4f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }




              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );

      //Vampire
      ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
          NameOverride = "Vampire", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = ""+"\n <color=red>Nameless aristocratic vampire, no one knows how old he is. He communicates with people like with cattle, but if he is interested in a person, he will passionately observe him. Breaks bone when touched.", //new item description
          CategoryOverride = ModAPI.FindCategory("MHW"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("Vampireview.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {
              //load textures for each layer (see Human textures folder in this repository)
              var skin = ModAPI.LoadTexture("Vampire.png");
              var flesh = ModAPI.LoadTexture("Cflesh.png");
              var bone = ModAPI.LoadTexture("bone layer .png");

              var person = Instance.GetComponent<PersonBehaviour>();

              var head = Instance.transform.Find("Head");
              var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
              var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
              var upper = Instance.transform.Find("Body").Find("UpperBody");
              arm1.gameObject.AddComponent<BreakeBone>();
              arm2.gameObject.AddComponent<BreakeBone>();

              foreach (var body in person.Limbs)
              {
                  body.BaseStrength += 7f;
                  body.Health *= 3.4f;
                  body.InitialHealth *= 2.4f;
                  body.ShotDamageMultiplier *= 0.2f;
                  body.BreakingThreshold += 12f;
                  body.RegenerationSpeed += 18f;
                  body.Vitality *= 5f;
                  body.ImpactPainMultiplier *= 0.2f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 2f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<DG>();

              }

              //use the helper function to set each texture
              //parameters are as follows:
              //  skin texture, flesh texture, bone texture, sprite scale
              //you can pass "null" to fall back to the original texture
              person.SetBodyTextures(skin, flesh, bone, 1);
              person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
              person.SetSecondBruiseColor(178, 34, 34); //second bruise colour. red by default
              person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
              person.SetBloodColour(139, 0, 0); // blood clour. dark red by default
              person.SetRottenColour(0, 0, 0);
          }
      }
  );



          //Dragon Sword
            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Sword"),
                  NameOverride = "Dragon Sword",
                  NameToOrderByOverride = "DS",
                  DescriptionOverride = "Weapons used by dragons humans. Sets the target on fire",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("DSview.png", 5f),
                  AfterSpawn = (generatorInstance) =>
                  {
                    generatorInstance.AddComponent<GreenBrickSword>();
                    generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Dragon Sword.png", 10f);
                  }
              }
          );

          //Dubina Trolla
            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),
                  NameOverride = "Troll's Cudgel",
                  NameToOrderByOverride = "Dubina blyat",
                  DescriptionOverride = "No supernatural powers, only physical strengt!",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("Dubina_view.png", 5f),
                  AfterSpawn = (Instance) =>
                  {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Dubina.png", 5f);
                    Instance.FixColliders();
                  }
              }
          );

          //Dragon Dagger
            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Knife"),
                  NameOverride = "Dragon Dagger",
                  NameToOrderByOverride = "DD",
                  DescriptionOverride = "Weapons used by dragons humans. Sets the target on fire",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("DDview.png", 5f),
                  AfterSpawn = (generatorInstance) =>
                  {
                    generatorInstance.AddComponent<GreenBrickSword>();
                    generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Dragon Dagger.png", 28f);
                  }
              }
          );


          //IceSword
            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Sword"),
                  NameOverride = "Ice Sword",
                  NameToOrderByOverride = "HS",
                  DescriptionOverride = "A magical ice sword that freezes the target if pierced.",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("IceSword_view.png", 5f),
                  AfterSpawn = (generatorInstance) =>
                  {
                    generatorInstance.AddComponent<GreenBrickSword3>();
                    generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("IceSword.png", 7f);
                  }
              }
          );

          //Vampire sword
            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Sword"),
                  NameOverride = "Vampire Sword",
                  NameToOrderByOverride = "VS",
                  DescriptionOverride = "A sword used by vampires of the nobility. When pierced, the victim becomes a zombie!",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("VSW.png", 5f),
                  AfterSpawn = (generatorInstance) =>
                  {
                    generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vimpire Sword.png", 10.5f);
                    generatorInstance.AddComponent<GreenBrickSword2>();
                  }
              }
          );


          //Techno
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Sword"),
                  NameOverride = "Techno Katana",
                  NameToOrderByOverride = "Demon Spear Wielded by High Threat Demons.",
                  DescriptionOverride = "Press F to Charge",
                  CategoryOverride = ModAPI.FindCategory("MHW"),
                  ThumbnailOverride = ModAPI.LoadSprite("sword4view.png", 5f),
                  AfterSpawn = (Instance) =>
                  {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Techno Katana.png", 13f);
                      Instance.GetComponent<PhysicalBehaviour>().Charge = 0f;
                      UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
                      useEventTrigger.Event = new UnityEvent();
                      useEventTrigger.Event.AddListener(delegate ()
                      {
                          Instance.GetComponent<PhysicalBehaviour>().Charge = 200f;
                      });
                    }
                }
            );

            }

            public static void OnLoad()
            {
                powersprites.pellet = ModAPI.LoadSprite("Fragments/pellet.png", 50f);

                powersprites.pellet2 = ModAPI.LoadSprite("Fragments/pellet1.png", 60f);

                powersprites.mag = ModAPI.LoadSprite("Fragments/Magic.png", 20f);

                powersprites.sword = ModAPI.LoadSprite("Fragments/Sword of the damned lord2.png", 2.8f);

       }
    }
}
